#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>

#include "gdbm.h"
#include "qDecoder.h"

#define TRUE	(1)
#define FALSE	(0)

#define BLOCK_SIZE	(1024 * 1)

void main(int argc, char **argv) {
  Entry *entries;
  GDBM_FILE dbf;
  datum key, data;
  char gdbmpath[0xff], ascpath[0xff];
  int  progress;

  if(argc != 3) {
    printf("Usage : convASC2GDBM ASC_PATH DB_PATH\n");
    printf("ex) convASC2GDBM data/test.asc data/test.gdbm\n");
    printf("ex) convASC2GDBM abcd.asc /htdocs/abcd.gdbm\n");
    exit(1);
  }

  strcpy(ascpath, argv[1]);
  strcpy(gdbmpath, argv[2]);

  entries = qfDecoder(ascpath);
  if(entries == NULL) {
    printf("ASCII file(%s) open fail.\n", ascpath);
    exit(1);
  }

  /* ȭ ϴ Ȯ */
  if(qCheckFile(gdbmpath) == TRUE) {
    printf("GDBM file(%s) already exist.\n", gdbmpath);
    exit(1);
  }

  /* DB create */
  dbf = gdbm_open(gdbmpath, BLOCK_SIZE, GDBM_WRCREAT, 0644, NULL);
  if(dbf == NULL) {
    printf("GDBM file(%s) creation fail.\n", gdbmpath);
    exit(1);
  }

  /* Main */
  printf("-- ASCII -> GDBM indian converting.\n");
  printf("-- Designed for 'CrazyWWWBoard'\n");
  printf("-- Source ASCII file : %s\n", ascpath);
  printf("-- Saved  GDBM  file : %s\n", gdbmpath);
  printf("\n");
  printf("Converting progress.\n");

  for(progress = 1; entries != NULL; entries = entries->next, progress++) {
    qURLdecode(entries->value);

    key.dptr   = entries->name;
    key.dsize  = strlen(entries->name) + 1;
    data.dptr  = entries->value;
    data.dsize = strlen(entries->value) + 1;

    gdbm_store(dbf, key, data, GDBM_INSERT);

    printf(".");
    if(progress % 60 == 0 ) printf("\n");
  }

  printf("\n");
  printf("Converted %d keys.\n", progress);
  printf("Converting completed.\n");

  /* close */
  gdbm_close(dbf);
  qfFree(entries);
}
